<?php
/*------------------------------------------------------------------------
# com_contentfake - Content Fake
# ------------------------------------------------------------------------
# author    Francisco Javier Félix Belmonte 
# copyright Copyright (C) 2012 www.inode64.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.inode64.com
# Technical Support:  http://www.inode64.com/Codigo/Joomla/Componente-CONTENT_FAKE-para-la-creacion-de-contenidos-falsos.html
-------------------------------------------------------------------------*/
defined('_JEXEC') or die('Restricted access');
 
jimport('joomla.application.component.modelitem');
jimport('joomla.filesystem.file');
 
class ContentFakeModelContentFake extends JModelItem
{
	protected $item;
	protected $patterns = array('//', '/[\s]+/', '/[\.]+/', '/[\|]+/');
	protected $join_chars = array('', ' ', '.', '|');
	
	public function getTable($type = 'ContentFake', $prefix = 'ContentFakeTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	private function rgb2array($rgb) {
	        return array(
						hexdec(substr($rgb, 0, 2)),
						hexdec(substr($rgb, 2, 2)),
						hexdec(substr($rgb, 4, 2))
	        );
	}

  private function create_image($file, $width, $height, $color)
	{

		$bgcolor = $this->rgb2array($color);

		$im = ImageCreate($width, $height);
		$bg = ImageColorAllocate($im, $bgcolor[0], $bgcolor[1], $bgcolor[2]);
		$text = $width . 'x' . $height;

		$color4 = ImageColorAllocate($im,255 - $bgcolor[0],255 - $bgcolor[1],255 - $bgcolor[2]);

		$ang = 0;
		$font = $width / 8;
		// determine numeric center of image
		$size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
		$X = ($width - (abs($size[2]- $size[0])))/2;
		$Y = (($height - (abs($size[5] - $size[3])))/2 + (abs($size[5] - $size[3])));
		if ( $width < 50 ) {
			if ( $height < 50 ) {
				$ang = 45;
				$font = $width / 6;
			    	$size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
			        $X = ($width - $size[4]) / 2;
				$Y = ($height - $size[3]) / 2;
			} elseif ( $height > $width ) {
			    $ang = 90;
			    $font = $height / 16;
			    $size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
			    $X = ($width - $size[4]) / 2 + 2;
			    $Y = ($height - $size[3]) / 2;
			}
		}

		//places numeric information on image
		ImageTTFText($im,$font,$ang,($X-1),$Y,$color4,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);

		ImagePNG($im, $file);

		return;
	}	
	
	private function get_text($pattern, $longtext, $n, $join_char){		
		$first_n = preg_split($pattern, $longtext, $n+1, PREG_SPLIT_NO_EMPTY);
		if ( count($first_n) > $n )
			array_pop($first_n);
		else 
			$first_n = $this->fillArray($first_n, $n);
		return join($join_char, $first_n).$join_char;
	}
	
	private function fillArray( $elements, $n){
		$size = count($elements);
		$to_go = $n - $size;
		
		$newElements = array();
		for( $i = 0; $i < $to_go; $i++)
			array_push($newElements, $elements[ $i % $size ]);
		
		return array_merge($elements, $newElements);
	}
	
	private function check_index($index,$count_array){
		return ($index >= $count_array) ? 0 : $index;
	}

	private function getImagePath(){
		return JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR;
	}

	private function getTextPosition($type){
		$style = '';
		switch ( $type ){
			case 4:
				$style = 'none';
				break;
			case 3:
				$style = 'justify';
				break;
			case 2:
				$style = 'center';
				break;
			case 1:
				$style = 'right';
				break;
			default:
			case 0:
				$style = 'left';
				break;
		}
		return $style;
	}
	
	private function getImagePosition( $type ){
		$style = '';
		switch ( $type ){
		case 2:
			$style = 'right';
			break;
		case 1:
			$style = 'left';
			break;
		default:
		case 0:
			$style = 'none';
			break;
		}
		return $style;
	}

	private function toParagraph( $text, $type ){
		$result  = '';
		switch ($type){
			case 2:
				$result = str_replace ('|', '<br />', $text);
				break;
			case 1:
				$result = '<div>' . str_replace ('|', '</div><div>', $text) . '</div>';
				break;
			default:
			case 0:
				$result = '<p>' . str_replace ('|', '</p><p>', $text) . '</p>';
				break;
		}
		return $result;
	}

	public function getMsg() 
	{
		if (!isset($this->item)) 
		{
			$this->item = new stdClass();
			
			$id = JRequest::getInt('id');
			$type = $this->check_index( JRequest::getInt('type'), count($this->patterns) ) ;
			$count = JRequest::getInt('count');
			$textalign = JRequest::getInt('textalign');
			
			$table = $this->getTable();
			$table->load($id);

			$width = JRequest::getInt('width');
			$height = JRequest::getInt('height');
			$color = JRequest::getString('imagebgcolor');
	    $md = md5("$width $height $color");
			
			$style = $this->getTextPosition(JRequest::getInt('textposition') );
			//Image
			$this->item->imageposition = $this->getImagePosition( JRequest::getInt('imageposition') );
			$this->item->dimension  = $width . 'px X ' . $height . 'px';
			$this->item->imagemargin = JRequest::getString('imagemargin');

			if (!JFile::exists($this->getImagePath().$md.'.png'))
				$this->create_image($this->getImagePath().$md.'.png',$width, $height, $color);
			
			$this->item->image = JURI::root().'media/contentfake/images/'.$md.'.png';
 
			//Text
			if ($style == 'none' )
				$this->item->text = '';
			else{
				$this->item->text = $this->toParagraph(
							$this->get_text($this->patterns[$type], $table->content, $count, $this->join_chars[$type] ), 
							JRequest::getInt('mode')
				);

				$this->item->text = "<div style='text-align:$style'>" . $this->item->text . "</div>";
			}
		}
		return $this->item;
	}
}
?>
